[glib: 1/5] ci: Correctly propagate exit status in run-style-check-diff.sh



commit 95479256df4a4693845be6a48dd85974c5c1c6d5
Author: Philip Withnall <withnall endlessm com>
Date:   Tue Feb 25 11:11:42 2020 +0000

    ci: Correctly propagate exit status in run-style-check-diff.sh
    
    Spotted by Daniel Stone: the addition of the `echo` commands in commit
    65541f1ad meant that the exit status from `clang-format-diff.py` was
    being lost.
    
    The incorrect use of `set +e` rather than `set -e` meant that
    intermediate commands could fail without the failure being noticed.
    
    Signed-off-by: Philip Withnall <withnall endlessm com>

 .gitlab-ci/run-style-check-diff.sh | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)
---
diff --git a/.gitlab-ci/run-style-check-diff.sh b/.gitlab-ci/run-style-check-diff.sh
index 097b43d60..f2dd5f378 100755
--- a/.gitlab-ci/run-style-check-diff.sh
+++ b/.gitlab-ci/run-style-check-diff.sh
@@ -1,6 +1,9 @@
 #!/bin/bash
 
-set +e
+set -e
+
+# Wrap everything in a subshell so we can propagate the exit status.
+(
 
 # We need to add a new remote for the upstream master, since this script could
 # be running in a personal fork of the repository which has out of date branches.
@@ -15,6 +18,9 @@ git fetch upstream
 newest_common_ancestor_sha=$(diff --old-line-format='' --new-line-format='' <(git rev-list --first-parent 
upstream/${CI_MERGE_REQUEST_TARGET_BRANCH_NAME:-${CI_DEFAULT_BRANCH}}) <(git rev-list --first-parent HEAD) | 
head -1)
 git diff -U0 --no-color "${newest_common_ancestor_sha}" | ./clang-format-diff.py -binary "clang-format-7" -p1
 
+)
+exit_status=$?
+
 # The style check is not infallible. The clang-format configuration cannot
 # perfectly describe GLib’s coding style: in particular, it cannot align
 # function arguments. The documented coding style for GLib takes priority over
@@ -29,3 +35,5 @@ echo "Note that clang-format output is advisory and cannot always match the GLib
 echo "   https://gitlab.gnome.org/GNOME/gtk/blob/master/docs/CODING-STYLE";
 echo "Warnings from this tool can be ignored in favour of the documented coding style,"
 echo "or in favour of matching the style of existing surrounding code."
+
+exit ${exit_status}


[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]